## qlcplus 4.13.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(qlcplus VERSION 4.13.1 LANGUAGES C CXX)

# Set Release build type by default
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# Prevent CMake make install strips off non-standard build paths
# Refer to https://stackoverflow.com/questions/7970544/cmake-make-install-output-cant-find-shared-qt-libraries-under-redhat
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

SET(INSTALL_ROOT "/" CACHE STRING "Installation root directory")

if(UNIX)
    if (APPLE)
        set(iokit ON)
    else()
        set(udev ON)
    endif()
endif()

if (ANDROID OR IOS)
    set(qmlui ON)
endif()

if (ANDROID)
    if(QT_VERSION_MAJOR GREATER 5)
        set(QT_ANDROID_PACKAGE_SOURCE_DIR ${PROJECT_SOURCE_DIR}/platforms/android CACHE INTERNAL "")
    else()
        set(ANDROID_PACKAGE_SOURCE_DIR ${PROJECT_SOURCE_DIR}/platforms/android CACHE INTERNAL "")
    endif()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up AUTOMOC and some sensible defaults for runtime execution
# When using Qt 6.3, you can replace the code block below with
# qt_standard_project_setup()
set(CMAKE_AUTOMOC ON)
include(GNUInstallDirs)

find_package(QT NAMES Qt5 Qt6 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui Multimedia MultimediaWidgets Network PrintSupport Qml Quick Svg Test Widgets LinguistTools)
if(qmlui)
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS 3DCore 3DInput 3DQuick 3DQuickExtras 3DRender)
    if(ANDROID)
        find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Concurrent OpenGL)
    endif()
endif()

message("Found Qt version ${QT_VERSION_MAJOR}: ${QT_DIR}")

if(QT_VERSION_MAJOR EQUAL 5)
    find_package(Qt${QT_VERSION_MAJOR} OPTIONAL_COMPONENTS Script)
endif()

find_package(PkgConfig REQUIRED)

include(./variables.cmake)
include(./coverage.cmake)

if((((QT_VERSION_MAJOR LESS 5)) AND (APPLE)))
    pkg_check_modules(PORTAUDIO_2 IMPORTED_TARGET portaudio-2.0)
endif()

if(WIN32)
    # Prefix all shared libraries with ''.
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif()

add_subdirectory(hotplugmonitor)
add_subdirectory(engine)
add_subdirectory(resources)
add_subdirectory(plugins)
if(qmlui)
    message("Building QLC+ 5 QML UI")
    add_subdirectory(qmlui)
else()
    message("Building QLC+ 4 QtWidget UI")
    add_subdirectory(ui)
    add_subdirectory(webaccess)
    add_subdirectory(main)
    add_subdirectory(fixtureeditor)
endif()
if(APPLE AND NOT qmlui)
    add_subdirectory(launcher)
endif()

# Unit testing thru "make check"
if(qmlui)
    if(WIN32)
       add_custom_target(unittests
            COMMAND unittest_cmake.bat "qmlui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    else()
       add_custom_target(unittests
            COMMAND ./unittest_cmake.sh "qmlui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    endif()
else()
    if(WIN32)
       add_custom_target(unittests
            COMMAND unittest_cmake.bat "ui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    else()
       add_custom_target(unittests
            COMMAND ./unittest_cmake.sh "ui" ${CMAKE_CURRENT_BINARY_DIR}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    endif()
endif()

add_custom_target(check
    DEPENDS unittests
)

# Unit test coverage measurement
if(WIN32)
    add_custom_target(coverage
        COMMAND @echo Get a better OS.
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
else()
    if(qmlui)
       add_custom_target(coverage
            COMMAND ./coverage_cmake.sh "qmlui"
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    else()
       add_custom_target(coverage
            COMMAND ./coverage_cmake.sh "ui"
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    endif()
endif()

add_custom_target(lcov
    DEPENDS coverage
)

# Translations
if (qmlui)
  add_custom_target(translations ALL
    COMMAND ./translate.sh "qmlui"
    COMMENT "Translating qmlui translations..."
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
else ()
  add_custom_target(translations ALL
    COMMAND ./translate.sh "ui"
    COMMENT "Translating ui translations..."
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

## Add the generated qm files to the list
file(GLOB translations_qm_files "${CMAKE_CURRENT_SOURCE_DIR}/*.qm")

## Install the qm files
if (appimage)
  set(translations_install_path "${TARGET_DIR}/${INSTALLROOT}/${TRANSLATIONDIR}")
else ()
  set(translations_install_path "${INSTALLROOT}/${TRANSLATIONDIR}")
endif()

install(FILES ${translations_qm_files} DESTINATION ${translations_install_path})

## Clean the generated files
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/*.qm")

# run
if(UNIX)
    if(qmlui)
       add_custom_target(run
            COMMAND ${CMAKE_COMMAND} -E env LD_LIBRARY_PATH=engine/src:$ENV{LD_LIBRARY_PATH} qmlui/qlcplus-qml
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    else()
       add_custom_target(run
            COMMAND ${CMAKE_COMMAND} -E env LD_LIBRARY_PATH=engine/src:ui/src:webaccess/src:$ENV{LD_LIBRARY_PATH} main/qlcplus
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    endif()
endif()

# run-fxe
if(UNIX AND NOT qmlui)
    add_custom_target(run-fxe
        COMMAND ${CMAKE_COMMAND} -E env LD_LIBRARY_PATH=engine/src:ui/src:webaccess/src:$ENV{LD_LIBRARY_PATH} ./fixtureeditor/qlcplus-fixtureeditor
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )
endif()

# doxygen
if(UNIX)
    add_custom_target(doxygen
        COMMAND cd resources/doxygen && rm -rf html/ && doxygen qlcplus.dox
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
endif()

# uninstall target
if(NOT TARGET uninstall)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

SET(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "qlcplus")
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Massimo Callegari") #required
INCLUDE(CPack)

# Leave this on the last row of this file
add_subdirectory(platforms)

=== fixtureeditor/CMakeLists.txt ===
set(module_name "qlcplus-fixtureeditor")

set(TS_FILES
    fixtureeditor_fi_FI.ts
    fixtureeditor_fr_FR.ts
    fixtureeditor_de_DE.ts
    fixtureeditor_es_ES.ts
    fixtureeditor_it_IT.ts
    fixtureeditor_nl_NL.ts
    fixtureeditor_cz_CZ.ts
    fixtureeditor_pt_BR.ts
    fixtureeditor_ca_ES.ts
    fixtureeditor_ja_JP.ts
)

if(QT_VERSION_MAJOR GREATER 5)
    qt_add_translation(QM_FILES ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()

add_executable(${module_name} WIN32 MACOSX_BUNDLE
    ../ui/src/aboutbox.cpp ../ui/src/aboutbox.h ../ui/src/aboutbox.ui
    ../ui/src/apputil.cpp ../ui/src/apputil.h
    ../ui/src/docbrowser.cpp ../ui/src/docbrowser.h
    addchannelsdialog.cpp addchannelsdialog.h addchannelsdialog.ui
    app.cpp app.h
    capabilitywizard.cpp capabilitywizard.h capabilitywizard.ui
    editchannel.cpp editchannel.h editchannel.ui
    edithead.cpp edithead.h edithead.ui
    editmode.cpp editmode.h editmode.ui
    editphysical.cpp editphysical.h editphysical.ui
    fixtureeditor.cpp fixtureeditor.h fixtureeditor.ui
    main.cpp
    util.h
    ${QM_FILES}
)

target_include_directories(${module_name} PRIVATE
    ../engine/src
    ../plugins/interfaces
    ../ui/src
)

target_link_libraries(${module_name} PRIVATE
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
    qlcplusengine
)


# Resources:
set_source_files_properties("../ui/src/../../resources/icons/png/add_dump.png"
    PROPERTIES QT_RESOURCE_ALIAS "add_dump.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/animation.png"
    PROPERTIES QT_RESOURCE_ALIAS "animation.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/attach.png"
    PROPERTIES QT_RESOURCE_ALIAS "attach.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/audio.png"
    PROPERTIES QT_RESOURCE_ALIAS "audio.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/audioinput.png"
    PROPERTIES QT_RESOURCE_ALIAS "audioinput.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/autostart.png"
    PROPERTIES QT_RESOURCE_ALIAS "autostart.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/back.png"
    PROPERTIES QT_RESOURCE_ALIAS "back.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/beam.png"
    PROPERTIES QT_RESOURCE_ALIAS "beam.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/blackout.png"
    PROPERTIES QT_RESOURCE_ALIAS "blackout.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/blind.png"
    PROPERTIES QT_RESOURCE_ALIAS "blind.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/button.png"
    PROPERTIES QT_RESOURCE_ALIAS "button.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/buttonmatrix.png"
    PROPERTIES QT_RESOURCE_ALIAS "buttonmatrix.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/chaser.png"
    PROPERTIES QT_RESOURCE_ALIAS "chaser.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/check.png"
    PROPERTIES QT_RESOURCE_ALIAS "check.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/checkbox_empty.png"
    PROPERTIES QT_RESOURCE_ALIAS "checkbox_empty.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/checkbox_full.png"
    PROPERTIES QT_RESOURCE_ALIAS "checkbox_full.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/clock.png"
    PROPERTIES QT_RESOURCE_ALIAS "clock.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/collection.png"
    PROPERTIES QT_RESOURCE_ALIAS "collection.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/color.png"
    PROPERTIES QT_RESOURCE_ALIAS "color.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/colorwheel.png"
    PROPERTIES QT_RESOURCE_ALIAS "colorwheel.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/configure.png"
    PROPERTIES QT_RESOURCE_ALIAS "configure.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/cuelist.png"
    PROPERTIES QT_RESOURCE_ALIAS "cuelist.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/current.png"
    PROPERTIES QT_RESOURCE_ALIAS "current.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/delete.png"
    PROPERTIES QT_RESOURCE_ALIAS "delete.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/design.png"
    PROPERTIES QT_RESOURCE_ALIAS "design.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/detach.png"
    PROPERTIES QT_RESOURCE_ALIAS "detach.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/dimmer.png"
    PROPERTIES QT_RESOURCE_ALIAS "dimmer.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/diptool.png"
    PROPERTIES QT_RESOURCE_ALIAS "diptool.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/down.png"
    PROPERTIES QT_RESOURCE_ALIAS "down.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_border.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_border.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_bottom.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_bottom.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_off.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_off.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_on.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_on.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ds_top.png"
    PROPERTIES QT_RESOURCE_ALIAS "ds_top.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/edit.png"
    PROPERTIES QT_RESOURCE_ALIAS "edit.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/edit_add.png"
    PROPERTIES QT_RESOURCE_ALIAS "edit_add.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/edit_remove.png"
    PROPERTIES QT_RESOURCE_ALIAS "edit_remove.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editclear.png"
    PROPERTIES QT_RESOURCE_ALIAS "editclear.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editcopy.png"
    PROPERTIES QT_RESOURCE_ALIAS "editcopy.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editcopyall.png"
    PROPERTIES QT_RESOURCE_ALIAS "editcopyall.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editcut.png"
    PROPERTIES QT_RESOURCE_ALIAS "editcut.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editdelete.png"
    PROPERTIES QT_RESOURCE_ALIAS "editdelete.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/editpaste.png"
    PROPERTIES QT_RESOURCE_ALIAS "editpaste.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/effect.png"
    PROPERTIES QT_RESOURCE_ALIAS "effect.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/efx.png"
    PROPERTIES QT_RESOURCE_ALIAS "efx.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/exit.png"
    PROPERTIES QT_RESOURCE_ALIAS "exit.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/expand.png"
    PROPERTIES QT_RESOURCE_ALIAS "expand.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fade.png"
    PROPERTIES QT_RESOURCE_ALIAS "fade.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fan.png"
    PROPERTIES QT_RESOURCE_ALIAS "fan.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileclose.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileclose.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileexport.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileexport.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileimport.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileimport.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/filenew.png"
    PROPERTIES QT_RESOURCE_ALIAS "filenew.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fileopen.png"
    PROPERTIES QT_RESOURCE_ALIAS "fileopen.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/filesave.png"
    PROPERTIES QT_RESOURCE_ALIAS "filesave.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/filesaveas.png"
    PROPERTIES QT_RESOURCE_ALIAS "filesaveas.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fixture.png"
    PROPERTIES QT_RESOURCE_ALIAS "fixture.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/flash.png"
    PROPERTIES QT_RESOURCE_ALIAS "flash.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/flower.png"
    PROPERTIES QT_RESOURCE_ALIAS "flower.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/folder.png"
    PROPERTIES QT_RESOURCE_ALIAS "folder.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fontcolor.png"
    PROPERTIES QT_RESOURCE_ALIAS "fontcolor.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fonts.png"
    PROPERTIES QT_RESOURCE_ALIAS "fonts.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/forward.png"
    PROPERTIES QT_RESOURCE_ALIAS "forward.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/frame.png"
    PROPERTIES QT_RESOURCE_ALIAS "frame.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/frameraised.png"
    PROPERTIES QT_RESOURCE_ALIAS "frameraised.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/framesunken.png"
    PROPERTIES QT_RESOURCE_ALIAS "framesunken.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/fullscreen.png"
    PROPERTIES QT_RESOURCE_ALIAS "fullscreen.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/function.png"
    PROPERTIES QT_RESOURCE_ALIAS "function.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/global.png"
    PROPERTIES QT_RESOURCE_ALIAS "global.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/gobo.png"
    PROPERTIES QT_RESOURCE_ALIAS "gobo.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/grid.png"
    PROPERTIES QT_RESOURCE_ALIAS "grid.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/group.png"
    PROPERTIES QT_RESOURCE_ALIAS "group.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/hazer.png"
    PROPERTIES QT_RESOURCE_ALIAS "hazer.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/help.png"
    PROPERTIES QT_RESOURCE_ALIAS "help.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/image.png"
    PROPERTIES QT_RESOURCE_ALIAS "image.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/input.png"
    PROPERTIES QT_RESOURCE_ALIAS "input.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/input_output.png"
    PROPERTIES QT_RESOURCE_ALIAS "input_output.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/intensity.png"
    PROPERTIES QT_RESOURCE_ALIAS "intensity.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/key_bindings.png"
    PROPERTIES QT_RESOURCE_ALIAS "key_bindings.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/knob.png"
    PROPERTIES QT_RESOURCE_ALIAS "knob.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/label.png"
    PROPERTIES QT_RESOURCE_ALIAS "label.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/laser.png"
    PROPERTIES QT_RESOURCE_ALIAS "laser.png"
)
set_source_files_properties("../ui/src/../../resources/icons/png/ledbar_beams.png"
    PROPERTIES QT_RESOURCE_ALIAS "ledbar_beams.png"
)

=== launcher/CMakeLists.txt ===
set(module_name "qlcplus-launcher")

set(TS_FILES
    launcher_fi_FI.ts
    launcher_de_DE.ts
    launcher_fr_FR.ts
    launcher_es_ES.ts
    launcher_it_IT.ts
    launcher_nl_NL.ts
    launcher_cz_CZ.ts
    launcher_pt_BR.ts
    launcher_ca_ES.ts
    launcher_ja_JP.ts
)

if(QT_VERSION_MAJOR GREATER 5)
    qt_add_translation(QM_FILES ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()

add_executable(${module_name} MACOSX_BUNDLE
    launcher.cpp launcher.h
    main.cpp
    ${QM_FILES}
)

target_include_directories(${module_name} PRIVATE
    ../engine/src
    ../plugins/interfaces
)

target_link_libraries(${module_name} PRIVATE
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
)

# Resources:
set_source_files_properties("../resources/icons/png/qlcplus-fixtureeditor.png"
    PROPERTIES QT_RESOURCE_ALIAS "qlcplus-fixtureeditor.png"
)
set_source_files_properties("../resources/icons/png/qlcplus.png"
    PROPERTIES QT_RESOURCE_ALIAS "qlcplus.png"
)
set(launcher_resource_files
    "../resources/icons/png/qlcplus-fixtureeditor.png"
    "../resources/icons/png/qlcplus.png"
)

if(QT_VERSION_MAJOR GREATER 5)
    qt_add_resources(${module_name} "launcher"
    PREFIX
        "/"
    BASE
        "."
    FILES
        ${launcher_resource_files}
)
else()
    qt5_add_resources($launcher.qrc)
    target_sources(${module_name} PRIVATE
        ${launcher_resource_files})
endif()

install(TARGETS ${module_name}
    DESTINATION ${INSTALLROOT}/${BINDIR}
)

=== main/CMakeLists.txt ===
set(module_name "qlcplus")

add_executable(${module_name} WIN32 MACOSX_BUNDLE
    main.cpp
)

target_include_directories(${module_name} PRIVATE
    ../engine/src
    ../ui/src
    ../ui/src/virtualconsole
    ../webaccess/src
)

target_link_libraries(${module_name} PRIVATE
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
    qlcplusengine
    qlcplusui
    qlcpluswebaccess
)


if(QT_VERSION_MAJOR EQUAL 5)
    qt5_add_resources(qlcplusui_resource_files ${CMAKE_SOURCE_DIR}/ui/src/qlcui.qrc)
    target_sources(${module_name} PRIVATE
        ${qlcplusui_resource_files}
    )
endif()

if(WIN32 OR APPLE)
    target_sources(${module_name} PRIVATE
        ../ui/src/debugbox.cpp ../ui/src/debugbox.h ../ui/src/debugbox.ui
    )
endif()

if(WIN32)
    target_sources(${module_name} PRIVATE
        main.rc
    )
endif()

if(qmlui OR (QT_VERSION_MAJOR GREATER 5))
    target_link_libraries(${module_name} PRIVATE
        Qt${QT_MAJOR_VERSION}::Qml
    )
else()
    target_link_libraries(${module_name} PRIVATE
        Qt${QT_MAJOR_VERSION}::Script
    )
endif()

install(TARGETS ${module_name}
    DESTINATION ${INSTALLROOT}/${BINDIR}
)

# Consider using qt_generate_deploy_app_script() for app deployment if
# the project can use Qt 6.3. In that case rerun qmake2cmake with
# --min-qt-version=6.3.

=== platforms/CMakeLists.txt ===
project(platforms)

if(UNIX AND NOT APPLE)
    add_subdirectory(linux)
endif()
if(WIN32)
    add_subdirectory(windows)
endif()

=== plugins/CMakeLists.txt ===
project(plugins)

# libusb-1.0
pkg_check_modules(LIBUSB_1 IMPORTED_TARGET libusb-1.0)

add_subdirectory(artnet)
add_subdirectory(E1.31)
add_subdirectory(loopback)
add_subdirectory(osc)

if(NOT ANDROID AND NOT IOS)
    pkg_check_modules(LIBOLA IMPORTED_TARGET libola)
    pkg_check_modules(LIBOLASERVER IMPORTED_TARGET libolaserver)

    add_subdirectory(dmxusb)
    add_subdirectory(peperoni)
    add_subdirectory(udmx)
    add_subdirectory(midi)
    add_subdirectory(velleman)
    add_subdirectory(enttecwing)
    add_subdirectory(hid)
    add_subdirectory(os2l)
if(UNIX AND NOT APPLE)
    add_subdirectory(dmx4linux)
endif()
if (NOT WIN32 AND NOT APPLE)
    add_subdirectory(spi)
endif()
if(UNIX AND ${LIBOLA_FOUND} AND ${LIBOLASERVER_FOUND})
    add_subdirectory(ola)
endif()

#    add_subdirectory(uart)
#    add_subdirectory(gpio)
endif()

=== qmlui/CMakeLists.txt ===
set(module_name "qlcplus-qml")

set(TS_FILES
    qlcplus_ca_ES.ts
    qlcplus_de_DE.ts
    qlcplus_es_ES.ts
    qlcplus_fr_FR.ts
    qlcplus_it_IT.ts
    qlcplus_ja_JP.ts
    qlcplus_nl_NL.ts
    qlcplus_pl_PL.ts
    qlcplus_ru_RU.ts
    qlcplus_uk_UA.ts
)

if(QT_VERSION_MAJOR GREATER 5)
    qt_add_translation(QM_FILES ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()

set(SRC_FILES
    app.cpp app.h
    audioeditor.cpp audioeditor.h
    chasereditor.cpp chasereditor.h
    collectioneditor.cpp collectioneditor.h
    colorfilters.cpp colorfilters.h
    contextmanager.cpp contextmanager.h
    efxeditor.cpp efxeditor.h
    fixturebrowser.cpp fixturebrowser.h
    fixtureeditor/channeledit.cpp fixtureeditor/channeledit.h
    fixtureeditor/editorview.cpp fixtureeditor/editorview.h
    fixtureeditor/fixtureeditor.cpp fixtureeditor/fixtureeditor.h
    fixtureeditor/modeedit.cpp fixtureeditor/modeedit.h
    fixtureeditor/physicaledit.cpp fixtureeditor/physicaledit.h
    fixturegroupeditor.cpp fixturegroupeditor.h
    fixturemanager.cpp fixturemanager.h
    fixtureutils.cpp fixtureutils.h
    functioneditor.cpp functioneditor.h
    functionmanager.cpp functionmanager.h
    importmanager.cpp importmanager.h
    inputoutputmanager.cpp inputoutputmanager.h
    inputprofileeditor.cpp inputprofileeditor.h
    listmodel.cpp listmodel.h
    main.cpp
    mainview2d.cpp mainview2d.h
    mainview3d.cpp mainview3d.h
    mainviewdmx.cpp mainviewdmx.h
    modelselector.cpp modelselector.h
    palettemanager.cpp palettemanager.h
    previewcontext.cpp previewcontext.h
    rgbmatrixeditor.cpp rgbmatrixeditor.h
    sceneeditor.cpp sceneeditor.h
    scripteditor.cpp scripteditor.h
    showmanager.cpp showmanager.h
    simpledesk.cpp simpledesk.h
    tardis/networkmanager.cpp tardis/networkmanager.h
    tardis/networkpacketizer.cpp tardis/networkpacketizer.h
    tardis/simplecrypt.cpp tardis/simplecrypt.h
    tardis/tardis.cpp tardis/tardis.h
    treemodel.cpp treemodel.h
    treemodelitem.cpp treemodelitem.h
    uimanager.cpp uimanager.h
    videoeditor.cpp videoeditor.h
    videoprovider.cpp videoprovider.h
    virtualconsole/vcanimation.cpp virtualconsole/vcanimation.h
    virtualconsole/vcaudiotrigger.cpp virtualconsole/vcaudiotrigger.h
    virtualconsole/vcbutton.cpp virtualconsole/vcbutton.h
    virtualconsole/vcclock.cpp virtualconsole/vcclock.h
    virtualconsole/vccuelist.cpp virtualconsole/vccuelist.h
    virtualconsole/vcframe.cpp virtualconsole/vcframe.h
    virtualconsole/vclabel.cpp virtualconsole/vclabel.h
    virtualconsole/vcpage.cpp virtualconsole/vcpage.h
    virtualconsole/vcslider.cpp virtualconsole/vcslider.h
    virtualconsole/vcsoloframe.cpp virtualconsole/vcsoloframe.h
    virtualconsole/vcwidget.cpp virtualconsole/vcwidget.h
    virtualconsole/vcxypad.cpp virtualconsole/vcxypad.h
    virtualconsole/vcspeeddial.cpp virtualconsole/vcspeeddial.h
    virtualconsole/virtualconsole.cpp virtualconsole/virtualconsole.h
)

if(ANDROID)
    add_library(${module_name} SHARED
        ${SRC_FILES}
        ${QM_FILES}
    )
    set_target_properties(
        ${module_name}
        PROPERTIES LIBRARY_OUTPUT_NAME qlcplus)
else()
    add_executable(${module_name} WIN32 MACOSX_BUNDLE
        ${SRC_FILES}
        ${QM_FILES}
    )
endif()

if(WIN32)
    target_sources(${module_name} PRIVATE
        qmlui.rc
    )
endif()

target_include_directories(${module_name} PRIVATE
    ../engine/audio/src
    ../engine/src
    ../plugins/interfaces
    ../plugins/midi/src/common
    fixtureeditor
    tardis
    virtualconsole
)

target_link_libraries(${module_name} PRIVATE
    Qt${QT_MAJOR_VERSION}::3DCore
    Qt${QT_MAJOR_VERSION}::3DInput
    Qt${QT_MAJOR_VERSION}::3DQuick
    Qt${QT_MAJOR_VERSION}::3DQuickExtras
    Qt${QT_MAJOR_VERSION}::3DRender
    Qt${QT_MAJOR_VERSION}::3DExtras
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Multimedia
    Qt${QT_MAJOR_VERSION}::MultimediaWidgets
    Qt${QT_MAJOR_VERSION}::PrintSupport
    Qt${QT_MAJOR_VERSION}::Qml
    Qt${QT_MAJOR_VERSION}::Quick
    Qt${QT_MAJOR_VERSION}::Svg
    Qt${QT_MAJOR_VERSION}::Widgets
    qlcplusengine
)

if(ANDROID)
    target_link_libraries(${module_name} PRIVATE
        Qt${QT_MAJOR_VERSION}::Concurrent
        Qt${QT_MAJOR_VERSION}::OpenGL
        GLESv2
        log
        z
        c++_shared
    )
endif()

if(lupdate_only)
    target_sources(${module_name} PRIVATE
        qml/*.qml
        qml/fixturesfunctions/*.qml
        qml/inputoutput/*.qml
        qml/popup/*.qml
        qml/showmanager/*.qml
        qml/virtualconsole/*.qml
    )
endif()

if(QT_VERSION_MAJOR EQUAL 5)
    qt5_add_resources(qlcplusqmlui_resource_files qmlui.qrc ../resources/icons/svg/svgicons.qrc ../resources/fonts/fonts.qrc)
    target_sources(${module_name} PUBLIC
        ${qlcplusqmlui_resource_files}
    )
else()
    qt_add_resources(qlcplusqmlui_resource_files qmlui.qrc ../resources/icons/svg/svgicons.qrc ../resources/fonts/fonts.qrc)
    target_sources(${module_name} PUBLIC
        ${qlcplusqmlui_resource_files}
    )
endif()

install(TARGETS ${module_name}
    DESTINATION ${INSTALLROOT}/${BINDIR}
)

=== engine/src/CMakeLists.txt ===
set(module_name "qlcplusengine")

add_library(${module_name} SHARED
    ../../plugins/interfaces/qlcioplugin.cpp ../../plugins/interfaces/qlcioplugin.h
    avolitesd4parser.cpp avolitesd4parser.h
    bus.cpp bus.h
    channelmodifier.cpp channelmodifier.h
    channelsgroup.cpp channelsgroup.h
    chaser.cpp chaser.h
    chaseraction.h
    chaserrunner.cpp chaserrunner.h
    chaserstep.cpp chaserstep.h
    collection.cpp collection.h
    cue.cpp cue.h
    cuestack.cpp cuestack.h
    dmxdumpfactoryproperties.cpp dmxdumpfactoryproperties.h
    dmxsource.h
    doc.cpp doc.h
    efx.cpp efx.h
    efxfixture.cpp efxfixture.h
    fadechannel.cpp fadechannel.h
    fixture.cpp fixture.h
    fixturegroup.cpp fixturegroup.h
    function.cpp function.h
    genericdmxsource.cpp genericdmxsource.h
    genericfader.cpp genericfader.h
    gradient.cpp gradient.h
    grandmaster.cpp grandmaster.h
    grouphead.cpp grouphead.h
    inputoutputmap.cpp inputoutputmap.h
    inputpatch.cpp inputpatch.h
    ioplugincache.cpp ioplugincache.h
    keypadparser.cpp keypadparser.h
    mastertimer.cpp mastertimer.h
    monitorproperties.cpp monitorproperties.h
    outputpatch.cpp outputpatch.h
    qlccapability.cpp qlccapability.h
    qlcchannel.cpp qlcchannel.h
    qlcclipboard.cpp qlcclipboard.h
    qlcfile.cpp qlcfile.h
    qlcfixturedef.cpp qlcfixturedef.h
    qlcfixturedefcache.cpp qlcfixturedefcache.h
    qlcfixturehead.cpp qlcfixturehead.h
    qlcfixturemode.cpp qlcfixturemode.h
    qlci18n.cpp qlci18n.h
    qlcinputchannel.cpp qlcinputchannel.h
    qlcinputfeedback.cpp qlcinputfeedback.h
    qlcinputprofile.cpp qlcinputprofile.h
    qlcinputsource.cpp qlcinputsource.h
    qlcmodifierscache.cpp qlcmodifierscache.h
    qlcpalette.cpp qlcpalette.h
    qlcphysical.cpp qlcphysical.h
    qlcpoint.cpp qlcpoint.h
    rgbalgorithm.cpp rgbalgorithm.h
    rgbaudio.cpp rgbaudio.h
    rgbimage.cpp rgbimage.h
    rgbmatrix.cpp rgbmatrix.h
    rgbplain.cpp rgbplain.h
    rgbscriptproperty.h
    rgbscriptscache.cpp rgbscriptscache.h
    rgbtext.cpp rgbtext.h
    scene.cpp scene.h
    scenevalue.cpp scenevalue.h
    scriptwrapper.h
    sequence.cpp sequence.h
    show.cpp show.h
    showfunction.cpp showfunction.h
    showrunner.cpp showrunner.h
    track.cpp track.h
    universe.cpp universe.h
    utils.h
    video.cpp video.h
)
target_include_directories(${module_name} PUBLIC
    ../../plugins/interfaces
    ../audio/src
)

target_link_libraries(${module_name} PUBLIC
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Multimedia
)

target_link_libraries(${module_name} PRIVATE
    qlcplusaudio
)

if(NOT ANDROID AND NOT IOS)
    target_include_directories(${module_name} PUBLIC
        ../../hotplugmonitor/src
    )

    target_link_libraries(${module_name} PUBLIC
        hotplugmonitor
    )

    target_link_directories(${module_name} PUBLIC
        ${CMAKE_CURRENT_BINARY_DIR}/../../hotplugmonitor/src
    )
endif()

if(UNIX AND NOT ANDROID AND NOT IOS AND NOT APPLE)
    target_link_libraries(${module_name} PUBLIC
        asound
    )
endif()

if(WIN32)
    target_sources(${module_name} PRIVATE
        mastertimer-win32.cpp mastertimer-win32.h
    )

    target_include_directories(${module_name} PUBLIC
        /
    )

    target_link_libraries(${module_name} PUBLIC
        Qt${QT_MAJOR_VERSION}::Widgets
        winmm
    )
endif()

if((NOT ANDROID AND NOT IOS) AND (iokit))
    target_link_libraries(${module_name} PUBLIC
        "-framework CoreFoundation"
        "-framework IOKit"
    )
endif()

if(APPLE)
    set_target_properties(${module_name} PROPERTIES
        MACOSX_BUNDLE FALSE
    )
    target_link_libraries(${module_name} PUBLIC
        "-framework AudioToolbox"
        "-framework CoreAudio"
        "-framework CoreFoundation"
    )
endif()

if(qmlui OR (QT_VERSION_MAJOR GREATER 5))
    target_sources(${module_name} PRIVATE
        rgbscriptv4.cpp rgbscriptv4.h
        scriptrunner.cpp scriptrunner.h
        scriptv4.cpp scriptv4.h
    )

    target_link_libraries(${module_name} PUBLIC
        Qt${QT_MAJOR_VERSION}::Qml
    )
endif()

if(NOT (qmlui OR (QT_VERSION_MAJOR GREATER 5)))
    target_sources(${module_name} PRIVATE
        rgbscript.cpp rgbscript.h
        script.cpp script.h
    )

    target_link_libraries(${module_name} PUBLIC
        Qt${QT_MAJOR_VERSION}::Script
    )
endif()

if(UNIX)
    target_sources(${module_name} PRIVATE
        mastertimer-unix.cpp mastertimer-unix.h
    )
endif()

if((NOT ANDROID AND NOT IOS) AND (${FFTW3_FOUND}))
    target_compile_definitions(${module_name} PUBLIC
        HAS_FFTW3
    )
endif()

if(((NOT ANDROID AND NOT IOS) AND (${FFTW3_FOUND})))
    target_link_directories(${module_name} PUBLIC
        ${FFTW3_LIBRARY_DIRS}
    )
    target_link_libraries(${module_name} PUBLIC
        ${FFTW3_LIBRARIES}
    )
endif()

set(CONFIGFILE ${CMAKE_SOURCE_DIR}/engine/src/qlcconfig.h)
set(LITERAL_HASH "#")

if(WIN32 OR APPLE OR appimage)
    configure_file(qlcconfig.h.noroot.in ${CONFIGFILE})
elseif(UNIX OR ANDROID OR IOS)
    configure_file(qlcconfig.h.in ${CONFIGFILE})
endif()

set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${CONFIGFILE})

install(TARGETS ${module_name}
    LIBRARY DESTINATION ${INSTALLROOT}/${LIBSDIR}
    RUNTIME DESTINATION ${INSTALLROOT}/${LIBSDIR}
)

=== hotplugmonitor/src/CMakeLists.txt ===
add_library(hotplugmonitor
    hotplugmonitor.cpp hotplugmonitor.h
)
set_property(TARGET hotplugmonitor PROPERTY POSITION_INDEPENDENT_CODE ON)

target_link_libraries(hotplugmonitor PUBLIC
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
)

if(udev)
    target_sources(hotplugmonitor PRIVATE
        hpmprivate-udev.cpp hpmprivate-udev.h
    )
    target_link_libraries(hotplugmonitor PRIVATE
        udev
    )
endif()

if(iokit)
    target_sources(hotplugmonitor PRIVATE
        hpmprivate-iokit.cpp hpmprivate-iokit.h
    )

    target_link_libraries(hotplugmonitor PUBLIC
        "-framework CoreFoundation"
        "-framework IOKit"
    )
endif()

if(WIN32)
    target_sources(hotplugmonitor PRIVATE
        hpmprivate-win32.cpp hpmprivate-win32.h
    )
endif()

=== platforms/linux/CMakeLists.txt ===
project(icons)

set(desktop_FILES qlcplus.desktop)
if(NOT qmlui)
    list(APPEND desktop_FILES qlcplus-fixtureeditor.desktop)
endif()
install(FILES ${desktop_FILES} DESTINATION ${INSTALLROOT}/share/applications/)

set(icons_SRCS ../../resources/icons/png/qlcplus.png)
if(NOT qmlui)
    list(APPEND icons_SRCS ../../resources/icons/png/qlcplus-fixtureeditor.png)
endif()
install(FILES ${icons_SRCS} DESTINATION ${INSTALLROOT}/share/pixmaps/)

install(FILES qlcplus.xml DESTINATION ${INSTALLROOT}/share/mime/packages)

set(appdata_FILES org.qlcplus.QLCPlus.appdata.xml)
if(NOT qmlui)
    list(APPEND appdata_FILES org.qlcplus.QLCPlusFixtureEditor.appdata.xml)
endif()
install(FILES ${appdata_FILES} DESTINATION ${METAINFODIR})

if(NOT qmlui)
    file(GLOB manpages_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.1")
    install(FILES ${manpages_FILES} DESTINATION ${INSTALLROOT}/${MANDIR})
endif()

# install(FILES ../Sample.qxw DESTINATION ${INSTALLROOT}/${DATADIR})
# install(FILES qlcplus-start.sh DESTINATION ${INSTALLROOT}/sbin)

if(appimage)
    if (QT_DIR STREQUAL "/usr/lib/x86_64-linux-gnu/cmake/Qt5")
        set(QT_LIBS_PATH "/usr/lib/x86_64-linux-gnu")
        set(QT_PLUGINS_PATH "/usr/lib/x86_64-linux-gnu/qt5/plugins")
        set(QT_QML_PATH "/usr/lib/x86_64-linux-gnu/qt5/qml")
    else()
        get_filename_component(QT_LIBS_PATH ${QT_DIR}/../../../lib ABSOLUTE)
        get_filename_component(QT_PLUGINS_PATH ${QT_LIBS_PATH}/../plugins ABSOLUTE)
        get_filename_component(QT_QML_PATH ${QT_LIBS_PATH}/../qml ABSOLUTE)
    endif()
    message("QT_LIBS_PATH ${QT_LIBS_PATH}")
    message("QT_PLUGINS_PATH ${QT_PLUGINS_PATH}")
    message("QT_QML_PATH ${QT_QML_PATH}")
    # Qt dependencies
    file(GLOB qtdeps_FILES "${QT_LIBS_PATH}/libicu*")
    install(
        FILES ${qtdeps_FILES}
        DESTINATION ${INSTALLROOT}/${LIBSDIR}
    )

    # Qt Libraries
    set(qtlibs_FILES
        ${QT_LIBS_PATH}/libQt5Core.so.5
        ${QT_LIBS_PATH}/libQt5Script.so.5
        ${QT_LIBS_PATH}/libQt5Network.so.5
        ${QT_LIBS_PATH}/libQt5Gui.so.5
        ${QT_LIBS_PATH}/libQt5Svg.so.5
        ${QT_LIBS_PATH}/libQt5Widgets.so.5
        ${QT_LIBS_PATH}/libQt5OpenGL.so.5
        ${QT_LIBS_PATH}/libQt5Multimedia.so.5
        ${QT_LIBS_PATH}/libQt5MultimediaWidgets.so.5
        ${QT_LIBS_PATH}/libQt5SerialPort.so.5
        ${QT_LIBS_PATH}/libQt5XcbQpa.so.5
        ${QT_LIBS_PATH}/libQt5DBus.so.5
    )
    if(qmlui)
        list(APPEND qtlibs_FILES
            ${QT_LIBS_PATH}/libQt5MultimediaQuick.so.5
            ${QT_LIBS_PATH}/libQt5MultimediaGstTools.so.5
            ${QT_LIBS_PATH}/libQt5Qml.so.5
            ${QT_LIBS_PATH}/libQt5QmlModels.so.5
            ${QT_LIBS_PATH}/libQt5QmlWorkerScript.so.5
            ${QT_LIBS_PATH}/libQt5Quick.so.5
            ${QT_LIBS_PATH}/libQt5QuickControls2.so.5
            ${QT_LIBS_PATH}/libQt5QuickTemplates2.so.5
            ${QT_LIBS_PATH}/libQt53DCore.so.5
            ${QT_LIBS_PATH}/libQt53DExtras.so.5
            ${QT_LIBS_PATH}/libQt53DInput.so.5
            ${QT_LIBS_PATH}/libQt53DLogic.so.5
            ${QT_LIBS_PATH}/libQt53DAnimation.so.5
            ${QT_LIBS_PATH}/libQt53DQuick.so.5
            ${QT_LIBS_PATH}/libQt53DQuickExtras.so.5
            ${QT_LIBS_PATH}/libQt53DQuickInput.so.5
            ${QT_LIBS_PATH}/libQt53DQuickRender.so.5
            ${QT_LIBS_PATH}/libQt53DRender.so.5
            ${QT_LIBS_PATH}/libQt5Concurrent.so.5
            ${QT_LIBS_PATH}/libQt5Gamepad.so.5
            ${QT_LIBS_PATH}/libQt5PrintSupport.so.5)
    endif()
    
    set(_resolved_qtlibs_FILES "")
    foreach (_file ${qtlibs_FILES})
        file(GLOB _files "${_file}*")
        list(FILTER _files EXCLUDE REGEX ".debug")
        list (APPEND _resolved_qtlibs_FILES "${_files}")
    endforeach()
    install(FILES ${_resolved_qtlibs_FILES} DESTINATION ${INSTALLROOT}/${LIBSDIR})

    # Qt plugins
    install(
        FILES 
            ${QT_PLUGINS_PATH}/platforms/libqlinuxfb.so
            ${QT_PLUGINS_PATH}/platforms/libqxcb.so
            ${QT_PLUGINS_PATH}/platforms/libqminimal.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/platforms
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/xcbglintegrations/libqxcb-glx-integration.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/xcbglintegrations
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/audio/libqtaudio_alsa.so
            ${QT_PLUGINS_PATH}/audio/libqtmedia_pulse.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/audio
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/mediaservice/libgstaudiodecoder.so
            ${QT_PLUGINS_PATH}/mediaservice/libgstmediaplayer.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/mediaservice
    )

    install(
        FILES
            ${QT_PLUGINS_PATH}/imageformats/libqsvg.so
        DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/imageformats
    )

    if(qmlui)
        install(
            FILES
                ${QT_PLUGINS_PATH}/printsupport/libcupsprintersupport.so
            DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/printsupport
        )

        install(
            FILES
                ${QT_PLUGINS_PATH}/sceneparsers/libassimpsceneimport.so
            OPTIONAL DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/sceneparsers
        )

        install(
            FILES
                ${QT_PLUGINS_PATH}/geometryloaders/libdefaultgeometryloader.so
            DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/geometryloaders
        )
    endif()

    if(QT_VERSION VERSION_GREATER_EQUAL 5.15.0)
        install(FILES ${QT_PLUGINS_PATH}/renderers/libopenglrenderer.so DESTINATION ${INSTALLROOT}/${LIBSDIR}/qt5/plugins/renderers)
    endif()

    set(qmldeps_files
        ${QT_QML_PATH}/QtQml
        ${QT_QML_PATH}/QtQuick
        ${QT_QML_PATH}/QtQuick.2
        ${QT_QML_PATH}/Qt3D
        ${QT_QML_PATH}/QtMultimedia
    )
    install(DIRECTORY ${qmldeps_files} DESTINATION ${INSTALLROOT}/bin)

endif()

=== platforms/windows/CMakeLists.txt ===
project(windows)
# Set QT version
if(QT_MAJOR_VERSION GREATER 5)
    set(QT_V "Qt6")
    set(QT_P "qt6")
else()
    set(QT_V "Qt5")
    set(QT_P "qt5")
endif()

# Set debug mode
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(QT_D "d")
else()
    set(QT_D "")
endif()

# Set paths
# message("${QT_LIBRARY_DIR}")
get_filename_component(QT_LIBS_PATH ${QT_DIR}/../../../bin ABSOLUTE)
get_filename_component(QT_PLUGINS_PATH ${QT_LIBS_PATH}/../share/${QT_P}/plugins ABSOLUTE)
get_filename_component(QT_QML_PATH ${QT_LIBS_PATH}/../share/${QT_P}/qml ABSOLUTE)
set(SYS_LIBS_PATH $ENV{SystemDrive}/msys64/mingw64/bin)
# set(SYS_LIBS_PATH D:/msys64/mingw32/bin)

# Qt library dependencies
set(qtdeps_path "${INSTALLROOT}/${LIBSDIR}")
set(qtdeps_files
    "${SYS_LIBS_PATH}/libbz2-1.dll"
    "${SYS_LIBS_PATH}/libfreetype-6.dll"
    "${SYS_LIBS_PATH}/libglib-2.0-0.dll"
    "${SYS_LIBS_PATH}/libgraphite2.dll"
    "${SYS_LIBS_PATH}/libharfbuzz-0.dll"
    "${SYS_LIBS_PATH}/libdouble-conversion.dll"
    "${SYS_LIBS_PATH}/libiconv-2.dll"
    "${SYS_LIBS_PATH}/libintl-8.dll"
    "${SYS_LIBS_PATH}/libpcre2-8-0.dll"
    "${SYS_LIBS_PATH}/libpcre2-16-0.dll"
    "${SYS_LIBS_PATH}/libpcre-1.dll"
    "${SYS_LIBS_PATH}/libpng16-16.dll"
    "${SYS_LIBS_PATH}/libjpeg-8.dll"
    "${SYS_LIBS_PATH}/libspeex-1.dll"
    "${SYS_LIBS_PATH}/libzstd.dll"
    "${SYS_LIBS_PATH}/libbrotlidec.dll"
    "${SYS_LIBS_PATH}/libbrotlicommon.dll"
    "${SYS_LIBS_PATH}/zlib1.dll"
)

if(qmlui)
	list(APPEND qtdeps_files 
		"${SYS_LIBS_PATH}/libassimp-5.dll"
		"${SYS_LIBS_PATH}/libminizip-1.dll")
endif()

if(Qt5_MAJOR_VERSION GREATER 5)
    list(APPEND qtdeps_files "${SYS_LIBS_PATH}/libb2-1.dll")
endif()
install(FILES ${qtdeps_files} OPTIONAL DESTINATION ${qtdeps_path})

set(qtlibs_path "${INSTALLROOT}/${LIBSDIR}")
set(qtlibs_files
    "${QT_LIBS_PATH}/${QT_V}Core${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}Script${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}Network${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}Gui${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}Svg${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}Widgets${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}OpenGL${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}Multimedia${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}MultimediaWidgets${QT_D}.dll"
    "${QT_LIBS_PATH}/${QT_V}SerialPort${QT_D}.dll"
)
if(qmlui)
    list(APPEND qtlibs_files
        "${QT_LIBS_PATH}/${QT_V}Qml${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}QmlModels${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}QmlWorkerScript${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}Quick${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}QuickControls2${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}QuickTemplates2${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}Sql${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DCore${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DExtras${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DInput${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DLogic${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DAnimation${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuick${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickExtras${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickInput${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickAnimation${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DQuickRender${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}3DRender${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}Concurrent${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}Gamepad${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}PrintSupport${QT_D}.dll"
        "${QT_LIBS_PATH}/${QT_V}MultimediaQuick${QT_D}.dll"
    )
endif()
install(FILES ${qtlibs_files} DESTINATION ${qtlibs_path})

# Qt platform plugin
set(qtplatform_path "${INSTALLROOT}/${LIBSDIR}/platforms")
set(qtplatform_files "${QT_PLUGINS_PATH}/platforms/qwindows${QT_D}.dll")
install(FILES ${qtplatform_files} DESTINATION ${qtplatform_path})

# Qt styles plugin
set(qtstyles_path "${INSTALLROOT}/${LIBSDIR}/styles")
set(qtstyles_files "${QT_PLUGINS_PATH}/styles/qwindowsvistastyle${QT_D}.dll")
install(FILES ${qtstyles_files} DESTINATION ${qtstyles_path})

if(Qt5_MAJOR_VERSION GREATER 5)
    set(qtmedia_path "${INSTALLROOT}/${LIBSDIR}/multimedia")
    set(qtmedia_files "${QT_PLUGINS_PATH}/multimedia/ffmpegmediaplugin${QT_D}.dll"
                        "${QT_PLUGINS_PATH}/multimedia/windowsmediaplugin${QT_D}.dll")
    install(FILES ${qtmedia_files} DESTINATION ${qtmedia_path})
else()
    set(qtaudio_path "${INSTALLROOT}/${LIBSDIR}/audio")
    set(qtaudio_files "${QT_PLUGINS_PATH}/audio/qtaudio_windows${QT_D}.dll")
    install(FILES ${qtaudio_files} DESTINATION ${qtaudio_path})

    set(qtmedia_path "${INSTALLROOT}/${LIBSDIR}/mediaservice")
    set(qtmedia_files "${QT_PLUGINS_PATH}/mediaservice/dsengine${QT_D}.dll"
                        "${QT_PLUGINS_PATH}/mediaservice/qtmedia_audioengine${QT_D}.dll")
    install(FILES ${qtmedia_files} DESTINATION ${qtmedia_path})
endif()

set(qtimageformats_path "${INSTALLROOT}/${LIBSDIR}/imageformats")
set(qtimageformats_files "${QT_PLUGINS_PATH}/imageformats/qgif${QT_D}.dll"
                          "${QT_PLUGINS_PATH}/imageformats/qjpeg${QT_D}.dll"
                          "${QT_PLUGINS_PATH}/imageformats/qsvg${QT_D}.dll")
install(FILES ${qtimageformats_files} DESTINATION ${qtimageformats_path})

if(qmlui)
    set(qtprintsupport_path "${INSTALLROOT}/${LIBSDIR}/printsupport")
    set(qtprintsupport_files "${QT_PLUGINS_PATH}/printsupport/windowsprintersupport${QT_D}.dll")
    install(FILES ${qtprintsupport_files} DESTINATION ${qtprintsupport_path})

    set(geometryloaders_path "${INSTALLROOT}/${LIBSDIR}/geometryloaders")
    set(geometryloaders_files "${QT_PLUGINS_PATH}/geometryloaders/defaultgeometryloader${QT_D}.dll")
    install(FILES ${geometryloaders_files} DESTINATION ${geometryloaders_path})

    set(sceneparsers_path "${INSTALLROOT}/${LIBSDIR}/sceneparsers")
    set(sceneparsers_files "${QT_PLUGINS_PATH}/sceneparsers/assimpsceneimport${QT_D}.dll")
    install(FILES ${sceneparsers_files} DESTINATION ${sceneparsers_path})

    set(renderers_path "${INSTALLROOT}/${LIBSDIR}/renderers")
    set(renderers_files "${QT_PLUGINS_PATH}/renderers/openglrenderer${QT_D}.dll")
    install(FILES ${renderers_files} DESTINATION ${renderers_path})

    set(qmldeps_path "${INSTALLROOT}/${LIBSDIR}")
    set(qmldeps_files "${QT_QML_PATH}/Qt"
                       "${QT_QML_PATH}/QtQml"
                       "${QT_QML_PATH}/QtQuick"
                       "${QT_QML_PATH}/QtQuick.2"
                       "${QT_QML_PATH}/Qt3D"
                       "${QT_QML_PATH}/QtMultimedia")
    install(DIRECTORY ${qmldeps_files} DESTINATION ${qmldeps_path})

    set(qmlpostinstall_commands "
        cd ${INSTALLROOT}/${LIBSDIR} && \
        find . -name plugins.qmltypes -type f -delete && \
        find . -name *.qmlc -type f -delete && \
        rm -rf Qt/WebSockets Qt/labs/location QtQml/RemoteObjects \
        rm -rf QtQuick/Extras QtQuick/Particles.2 QtQuick/XmlListModel \
        rm -rf QtQuick/Controls.2/designer QtQuick/Controls.2/Material \
        rm -rf QtQuick/Controls.2/Universal QtQuick/Controls.2/Fusion \
        rm -rf QtQuick/Controls.2/Imagine QtQuick/Scene2D
    ")
    install(CODE "execute_process(COMMAND ${qmlpostinstall_commands})")
endif()

# MSYS2 libraries
set(msys_path "${INSTALLROOT}/${LIBSDIR}")
set(msys_files "${SYS_LIBS_PATH}/libstdc++-6.dll"
                "${SYS_LIBS_PATH}/libgcc_s_seh-1.dll"
                "${SYS_LIBS_PATH}/libwinpthread-1.dll"
                "${SYS_LIBS_PATH}/libicuin74.dll"
                "${SYS_LIBS_PATH}/libicuuc74.dll"
                "${SYS_LIBS_PATH}/libicudt74.dll"
                "${SYS_LIBS_PATH}/libmd4c.dll"
                "${SYS_LIBS_PATH}/libusb-1.0.dll")
install(FILES ${msys_files} DESTINATION ${msys_path})

# audio libraries
set(audio_path "${INSTALLROOT}/${LIBSDIR}")
if(EXISTS "${SYS_LIBS_PATH}/libmad-0.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libmad-0.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libogg-0.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libogg-0.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libopus-0.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libopus-0.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libmp3lame-0.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libmp3lame-0.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libmpg123-0.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libmpg123-0.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libvorbis-0.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libvorbis-0.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libvorbisenc-2.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libvorbisenc-2.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libFLAC.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libFLAC.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libsndfile-1.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libsndfile-1.dll")
endif()
if(EXISTS "${SYS_LIBS_PATH}/libfftw3-3.dll")
    list(APPEND audio_files "${SYS_LIBS_PATH}/libfftw3-3.dll")
endif()
install(FILES ${audio_files} DESTINATION ${audio_path})

# NullSoft installer files
set(nsis_path "${INSTALLROOT}/${DATADIR}")
if(qmlui)
    set(nsis_files qlcplus5${QT_V}.nsi)
else()
    set(nsis_files qlcplus4${QT_V}.nsi)
endif()
install(FILES ${nsis_files} DESTINATION ${nsis_path})

# install(FILES ../Sample.qxw DESTINATION ${INSTALLROOT}/${DATADIR})

=== plugins/gpio/CMakeLists.txt ===
set(module_name "gpio")

set(TS_FILES
    GPIO_de_DE.ts
    GPIO_es_ES.ts
    GPIO_fi_FI.ts
    GPIO_fr_FR.ts
    GPIO_it_IT.ts
    GPIO_nl_NL.ts
    GPIO_cz_CZ.ts
    GPIO_pt_BR.ts
    GPIO_ca_ES.ts
    GPIO_ja_JP.ts
)

if(QT_VERSION_MAJOR GREATER 5)
    qt_add_translation(QM_FILES ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()

project(${module_name})

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui Widgets)

add_library(${module_name} SHARED
    ${QM_FILES}
)
target_sources(${module_name} PRIVATE
    ../interfaces/qlcioplugin.cpp ../interfaces/qlcioplugin.h
    gpioconfiguration.cpp gpioconfiguration.h gpioconfiguration.ui
    gpioplugin.cpp gpioplugin.h
    gpioreaderthread.cpp gpioreaderthread.h
)
target_include_directories(${module_name} PRIVATE
    ../interfaces
)

target_link_libraries(${module_name} PRIVATE
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
)

install(TARGETS ${module_name}
    LIBRARY DESTINATION ${INSTALLROOT}/${PLUGINDIR}
    RUNTIME DESTINATION ${INSTALLROOT}/${PLUGINDIR}
)

=== debian/changelog ===
qlcplus (4.13.1-1) unstable; urgency=medium

  [ Chris Hofstaedtler ]
  * Use udev.pc to place udev files (Closes: #1058833)

  [ Jerome Lebleu ]
  * New upstream version 4.13.1
  * Update Build-Depends, patches and dh_auto_configure for CMake switch
  * d/control:
    + Replace pkg-config by pkgconf in Build-Depends
    + Bump Standards-Versions to 4.7.0 (no changes)
  * d/copyright: Update years of active developers
  * d/lintian-overrides: Extend and update overrides for private libraries
  * d/rules: Do not add ldconfig trigger for private libraries

 -- Jerome Lebleu <jerome@maroufle.fr>  Sat, 01 Jun 2024 14:12:47 +0200

=== debian/control ===
Source: qlcplus
Section: misc
Priority: optional
Maintainer: Jerome Lebleu <jerome@maroufle.fr>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libasound2-dev (>= 1.0.16),
               libfftw3-dev,
               libftdi1-dev,
               libmad0-dev,
               libqt5serialport5-dev,
               libqt5svg5-dev,
               libsndfile1-dev,
               libudev-dev,
               libusb-1.0-0-dev (>= 2:0.1.12),
               libxml2-utils,
               localehelper <!nocheck>,
               pkgconf,
               python3,
               python3-lxml,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qtscript5-dev,
               qttools5-dev,
               shared-mime-info (>= 0.71),
               systemd-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Standards-Version: 4.7.0
Homepage: https://www.qlcplus.org/
Vcs-Git: https://salsa.debian.org/jlebleu/qlcplus.git
Vcs-Browser: https://salsa.debian.org/jlebleu/qlcplus
Rules-Requires-Root: no

Package: qlcplus
Architecture: any
Depends: qlcplus-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: libmad0, libqt5multimedia5-plugins, libsndfile1
Description: Control DMX or analog lighting systems
 Q Light Controller Plus is a software lighting desk for controlling
 DMX or analog lighting systems like moving heads, dimmers, scanners.
 .
 This project is a fork of the great QLC project written by Heikki Junnila
 that aims to continue the QLC development and to introduce new features. The
 primary goal is to bring QLC+ at the level of other lighting control commercial
 software.

Package: qlcplus-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Control DMX or analog lighting systems (data files)
 Q Light Controller Plus is a software lighting desk for controlling
 DMX or analog lighting systems like moving heads, dimmers, scanners.
 .
 This project is a fork of the great QLC project written by Heikki Junnila
 that aims to continue the QLC development and to introduce new features. The
 primary goal is to bring QLC+ at the level of other lighting control commercial
 software.
 .
 This package contains architecture-independent data files.
